function [bestcost,omega_best_new,beta_best_new]=targraspbispr(omega_best,beta_best,hp,x,xhp,z,y,n,MAXGRASPITER,MAXHP,MAXLISTHP,bestcost,p,np)

[parhp,hpcost]=preproc(omega_best,beta_best,x,xhp,z,y,hp,n,MAXLISTHP,p,np,MAXHP);
[hpcost,ihpcost]=srtcst(hpcost,MAXLISTHP);
iter=0;

omega_best_new=[];
beta_best_new=[];

for i=1:MAXGRASPITER,
%   fprintf('%s\r','  ');
%   fprintf('%s\r','  ');
%   fprintf('%s\r','  ');
%   fprintf('%s\r','  ');
%   fprintf('%s','Iterazione numero: ');
%   fprintf('%6.0f\r',i);

   gamma=unifrnd(0,1,1,1);
   [omega,beta,cost,hpselect]=cgrsbis(omega_best,beta_best,parhp,hpcost,ihpcost,x,z,y,n,gamma,MAXHP,MAXLISTHP,p,np);
   
      
   % hyperplane rotation local search
   [omega,beta,cost]=lsrot(cost,x,z,y,hp(:,hpselect),xhp,omega,beta,n,MAXHP,p,np);
   
   
   % hyperplane translation local search
	[omega,beta,cost]=lstrans(cost,x,z,y,omega,beta,n,MAXHP,p,np);
      [lambda,alpha]=calcout(omega,beta,x,z,y,MAXHP,p,np);
   [y_hat,e]=transfer(omega,beta,lambda,alpha,x,z,y);
   mse=sumsqr(e)/np;
	sbic=log(mse)+(log(np)/(np))*(MAXHP*(p+n+1)+p);
   aic=log(mse)+2*(MAXHP*(p+n+1)+p)/np;
   if MAXHP==1
   	printsol(i,cost,sbic,aic,omega,beta);
	else
      printsol(i,cost,sbic,aic,omega(1,:),beta(1));
      for jj=2:MAXHP,
         printsol(omega(jj,:),beta(jj));
      end
   end
   
% 	fprintf('%s','cost: ');
%   fprintf('%6.6f\r',cost);
% 	fprintf('%s','Omega: ');
%   fprintf('%6.6f %2.6f\r',omega);
% 	fprintf('%s','Beta: ');
%   fprintf('%6f\r',beta);
% 	fprintf('%s','BestCost: ');
%   fprintf('%6f\r',bestcost);
% 	fprintf('%s','OmegaBest: ');
%   fprintf('%6.6f %16.6f\r',omega_best_new);
% 	fprintf('%s','BetaBest: ');
%   fprintf('%6f\r',beta_best_new);
   
   if cost<bestcost
      bestcost=cost;
      omega_best_new=omega;
      beta_best_new=beta;
   end
end


